// Quiz_Fadenpendel_Frage_1_Animation 
// 06.10.2014

// ****************************************************************************
// * Autor: Thomas Unkelbach fr LEIFIphysik.de                               *
// * Dieses Programm darf - auch in vernderter Form - fr nicht-kommerzielle *
// * Zwecke verwendet und weitergegeben werden, solange dieser Hinweis nicht  *
// * entfernt wird.                                                           *
// ****************************************************************************

var f1_canvas = document.getElementById('f1_leinwand');
var f1_context = f1_canvas.getContext('2d');
var f1_t0 = (new Date()).getTime();

var f1_Decke = {
	x: 0,
	y: 0,
	breite: 350,
	hoehe: 25,
	farbe: '#5B135C',
	randbreite: 0,
	randfarbe: '#FFFFFF',
	randenden: 'round'
	};

var f1_Faden = {
	xs: 175,
	ys: 25,
	xe: 175,
	ye: 125,
	farbe: '#000000',
	breite: 1,
	enden: 'round'
	};

var f1_Kugel = {
	x: 175,
	y: 125,
	r: 20,
	farbe: '#C3C800',
	randbreite: 0,
	randfarbe: 'FFFFFF'
	};

var f1_l = 1;
var f1_g = 9.81;
var f1_T = 2 * Math.PI * Math.sqrt(f1_l/f1_g);

var f1_phi0 = Math.PI / 20;
var f1_x0 = 175;
var f1_y0 = 25;
var f1_r = 120 * f1_l;


document.addEventListener("DOMContentLoaded",f1_simulation(),false);

function f1_simulation (){
	window.requestAnimFrame = (function(callback) {return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || function(callback) {window.setTimeout(callback, 1000 / 60);};})();
	f1_init ();
	f1_animate ();
	}

function f1_init () {
	f1_Kugel.x = f1_x0;
	f1_Kugel.y = f1_y0 + f1_r;

	f1_context.clearRect(0, 0, f1_canvas.width, f1_canvas.height);
	zeichneRechteck(f1_context,f1_Decke);
	f1_Faden.xe = f1_Kugel.x;
	f1_Faden.ye = f1_Kugel.y;
	zeichneLinie(f1_context,f1_Faden);
	zeichneKugel(f1_context,f1_Kugel);
	}

function f1_animate () {
	var t = ((new Date()).getTime() - f1_t0) / 1000;
	var phi = f1_phi0 * Math.sin(2 * Math.PI / f1_T * t);
	f1_Kugel.x = f1_x0 - f1_r * Math.sin(phi);
	f1_Kugel.y = f1_y0 + f1_r * Math.cos(phi);

	f1_context.clearRect(0, f1_Decke.hoehe, f1_canvas.width, f1_canvas.height-f1_Decke.hoehe);
	f1_Faden.xe = f1_Kugel.x;
	f1_Faden.ye = f1_Kugel.y;
	zeichneLinie(f1_context,f1_Faden);
	zeichneKugel(f1_context,f1_Kugel);

	requestAnimFrame(function() {f1_animate();});
	}

function zeichneRechteck(context,R) {
	context.beginPath();
	context.rect(R.x, R.y, R.breite, R.hoehe);
	context.fillStyle = R.farbe;
	context.fill();
	if (R.randbreite > 0){
		context.lineWidth = R.randbreite;
		context.strokeStyle = R.randfarbe;
		context.lineCap = R.randenden;
		context.stroke();
		}
	}

function zeichneLinie(context,L) {
	context.beginPath();
	context.moveTo(L.xs, L.ys);
	context.lineTo(L.xe, L.ye);
	context.strokeStyle = L.farbe;
	context.lineWidth = L.breite;
	context.lineCap = L.enden;
	context.stroke();
	}

function zeichneKugel (context,K) {
	context.beginPath();
	context.arc(K.x, K.y, K.r, 0, 2.0*Math.PI);
	var grd = context.createRadialGradient(K.x-K.r/3, K.y-K.r/3, 0, K.x, K.y, K.r);
	grd.addColorStop(0, '#FFFFFF');
	grd.addColorStop(1, K.farbe);
	context.fillStyle = grd;
	context.fill();
	if (K.randbreite > 0){
		context.lineWidth = K.randbreite;
		context.strokeStyle = K.randfarbe;
		context.stroke();
		}
	}