﻿// Quiz_Fadenpendel_Frage_2_Animation 
// 06.10.2014

// ****************************************************************************
// * Autor: Thomas Unkelbach für LEIFIphysik.de                               *
// * Dieses Programm darf - auch in veränderter Form - für nicht-kommerzielle *
// * Zwecke verwendet und weitergegeben werden, solange dieser Hinweis nicht  *
// * entfernt wird.                                                           *
// ****************************************************************************

var f2_canvas = document.getElementById('f2_leinwand');
var f2_context = f2_canvas.getContext('2d');
var f2_t0 = (new Date()).getTime();

var f2_Decke = {
	x: 0,
	y: 0,
	breite: 350,
	hoehe: 25,
	farbe: '#5B135C',
	randbreite: 0,
	randfarbe: '#FFFFFF',
	randenden: 'round'
	};

var f2_Faden1 = {
	xs: 100,
	ys: 25,
	xe: 100,
	ye: 125,
	farbe: '#000000',
	breite: 1,
	enden: 'round'
	};

var f2_Kugel1 = {
	x: 100,
	y: 125,
	r: 20,
	farbe: '#C3C800',
	randbreite: 0,
	randfarbe: 'FFFFFF'
	};

var f2_l1 = 1;
var f2_g1 = 9.81;
var f2_T1 = 2 * Math.PI * Math.sqrt(f2_l1/f2_g1);

var f2_phi01 = Math.PI / 20;
var f2_x01 = 100;
var f2_y01 = 25;
var f2_r1 = 120 * f2_l1;

var f2_Faden2 = {
	xs: 250,
	ys: 25,
	xe: 250,
	ye: 125,
	farbe: '#000000',
	breite: 1,
	enden: 'round'
	};

var f2_Kugel2 = {
	x: 250,
	y: 125,
	r: 20,
	farbe: '#C3C800',
	randbreite: 0,
	randfarbe: 'FFFFFF'
	};

var f2_l2 = 1.5;
var f2_g2 = 9.81;
var f2_T2 = 2 * Math.PI * Math.sqrt(f2_l2/f2_g2);

var f2_phi02 = Math.PI / 20;
var f2_x02 = 250;
var f2_y02 = 25;
var f2_r2 = 120 * f2_l2;


document.addEventListener("DOMContentLoaded",f2_simulation(),false);

function f2_simulation (){
	window.requestAnimFrame = (function(callback) {return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || function(callback) {window.setTimeout(callback, 1000 / 60);};})();
	f2_init ();
	f2_animate ();
	}

function f2_init () {
	f2_Kugel1.x = f2_x01;
	f2_Kugel1.y = f2_y01 + f2_r1;
	f2_Kugel2.x = f2_x02;
	f2_Kugel2.y = f2_y02 + f2_r2;

	f2_context.clearRect(0, 0, f2_canvas.width, f2_canvas.height);
	zeichneRechteck(f2_context,f2_Decke);
	f2_Faden1.xe = f2_Kugel1.x;
	f2_Faden1.ye = f2_Kugel1.y;
	zeichneLinie(f2_context,f2_Faden1);
	zeichneKugel(f2_context,f2_Kugel1);
	f2_Faden2.xe = f2_Kugel2.x;
	f2_Faden2.ye = f2_Kugel2.y;
	zeichneLinie(f2_context,f2_Faden2);
	zeichneKugel(f2_context,f2_Kugel2);
	}

function f2_animate () {
	var t = ((new Date()).getTime() - f2_t0) / 1000;
	var phi1 = f2_phi01 * Math.sin(2 * Math.PI / f2_T1 * t);
	f2_Kugel1.x = f2_x01 - f2_r1 * Math.sin(phi1);
	f2_Kugel1.y = f2_y01 + f2_r1 * Math.cos(phi1);
	var phi2 = f2_phi02 * Math.sin(2 * Math.PI / f2_T2 * t);
	f2_Kugel2.x = f2_x02 - f2_r2 * Math.sin(phi2);
	f2_Kugel2.y = f2_y02 + f2_r2 * Math.cos(phi2);

	f2_context.clearRect(0, f2_Decke.hoehe, f2_canvas.width, f2_canvas.height-f2_Decke.hoehe);
	f2_Faden1.xe = f2_Kugel1.x;
	f2_Faden1.ye = f2_Kugel1.y;
	zeichneLinie(f2_context,f2_Faden1);
	zeichneKugel(f2_context,f2_Kugel1);
	f2_Faden2.xe = f2_Kugel2.x;
	f2_Faden2.ye = f2_Kugel2.y;
	zeichneLinie(f2_context,f2_Faden2);
	zeichneKugel(f2_context,f2_Kugel2);

	requestAnimFrame(function() {f2_animate();});
	}

function zeichneRechteck(context,R) {
	context.beginPath();
	context.rect(R.x, R.y, R.breite, R.hoehe);
	context.fillStyle = R.farbe;
	context.fill();
	if (R.randbreite > 0){
		context.lineWidth = R.randbreite;
		context.strokeStyle = R.randfarbe;
		context.lineCap = R.randenden;
		context.stroke();
		}
	}

function zeichneLinie(context,L) {
	context.beginPath();
	context.moveTo(L.xs, L.ys);
	context.lineTo(L.xe, L.ye);
	context.strokeStyle = L.farbe;
	context.lineWidth = L.breite;
	context.lineCap = L.enden;
	context.stroke();
	}

function zeichneKugel (context,K) {
	context.beginPath();
	context.arc(K.x, K.y, K.r, 0, 2.0*Math.PI);
	var grd = context.createRadialGradient(K.x-K.r/3, K.y-K.r/3, 0, K.x, K.y, K.r);
	grd.addColorStop(0, '#FFFFFF');
	grd.addColorStop(1, K.farbe);
	context.fillStyle = grd;
	context.fill();
	if (K.randbreite > 0){
		context.lineWidth = K.randbreite;
		context.strokeStyle = K.randfarbe;
		context.stroke();
		}
	}