﻿// Quiz_Fadenpendel_Frage_4_Animation 
// 06.10.2014

// ****************************************************************************
// * Autor: Thomas Unkelbach für LEIFIphysik.de                               *
// * Dieses Programm darf - auch in veränderter Form - für nicht-kommerzielle *
// * Zwecke verwendet und weitergegeben werden, solange dieser Hinweis nicht  *
// * entfernt wird.                                                           *
// ****************************************************************************

var f4_canvas = document.getElementById('f4_leinwand');
var f4_context = f4_canvas.getContext('2d');
var f4_t0 = (new Date()).getTime();

var f4_Decke = {
	x: 0,
	y: 0,
	breite: 350,
	hoehe: 25,
	farbe: '#5B135C',
	randbreite: 0,
	randfarbe: '#FFFFFF',
	randenden: 'round'
	};

var f4_Faden1 = {
	xs: 100,
	ys: 25,
	xe: 100,
	ye: 125,
	farbe: '#000000',
	breite: 1,
	enden: 'round'
	};

var f4_Kugel1 = {
	x: 100,
	y: 125,
	r: 20,
	farbe: '#C3C800',
	randbreite: 0,
	randfarbe: 'FFFFFF'
	};

var f4_l1 = 1;
var f4_g1 = 9.81;
var f4_T1 = 2 * Math.PI * Math.sqrt(f4_l1/f4_g1);

var f4_phi01 = Math.PI / 20;
var f4_x01 = 100;
var f4_y01 = 25;
var f4_r1 = 120 * f4_l1;

var f4_Faden2 = {
	xs: 250,
	ys: 25,
	xe: 250,
	ye: 125,
	farbe: '#000000',
	breite: 1,
	enden: 'round'
	};

var f4_Kugel2 = {
	x: 250,
	y: 125,
	r: 20,
	farbe: '#C3C800',
	randbreite: 0,
	randfarbe: 'FFFFFF'
	};

var f4_l2 = 1;
var f4_g2 = 15;
var f4_T2 = 2 * Math.PI * Math.sqrt(f4_l2/f4_g2);

var f4_phi02 = Math.PI / 20;
var f4_x02 = 250;
var f4_y02 = 25;
var f4_r2 = 120 * f4_l2;


document.addEventListener("DOMContentLoaded",f4_simulation(),false);

function f4_simulation (){
	window.requestAnimFrame = (function(callback) {return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || function(callback) {window.setTimeout(callback, 1000 / 60);};})();
	f4_init ();
	f4_animate ();
	}

function f4_init () {
	f4_Kugel1.x = f4_x01;
	f4_Kugel1.y = f4_y01 + f4_r1;
	f4_Kugel2.x = f4_x02;
	f4_Kugel2.y = f4_y02 + f4_r2;

	f4_context.clearRect(0, 0, f4_canvas.width, f4_canvas.height);
	zeichneRechteck(f4_context,f4_Decke);
	f4_Faden1.xe = f4_Kugel1.x;
	f4_Faden1.ye = f4_Kugel1.y;
	zeichneLinie(f4_context,f4_Faden1);
	zeichneKugel(f4_context,f4_Kugel1);
	zeichneText(f4_context,'g',94,200,'16pt Arial','#000000');
	zeichneText(f4_context,'1',106,205,'10pt Arial','#000000');
	f4_Faden2.xe = f4_Kugel2.x;
	f4_Faden2.ye = f4_Kugel2.y;
	zeichneLinie(f4_context,f4_Faden2);
	zeichneKugel(f4_context,f4_Kugel2);
	zeichneText(f4_context,'g  > g',225,200,'16pt Arial','#000000');
	zeichneText(f4_context,'2',237,205,'10pt Arial','#000000');
	zeichneText(f4_context,'1',278,205,'10pt Arial','#000000');
	}

function f4_animate () {
	var t = ((new Date()).getTime() - f4_t0) / 1000;
	var phi1 = f4_phi01 * Math.sin(2 * Math.PI / f4_T1 * t);
	f4_Kugel1.x = f4_x01 - f4_r1 * Math.sin(phi1);
	f4_Kugel1.y = f4_y01 + f4_r1 * Math.cos(phi1);
	var phi2 = f4_phi02 * Math.sin(2 * Math.PI / f4_T2 * t);
	f4_Kugel2.x = f4_x02 - f4_r2 * Math.sin(phi2);
	f4_Kugel2.y = f4_y02 + f4_r2 * Math.cos(phi2);

	f4_context.clearRect(0, f4_Decke.hoehe, f4_canvas.width, f4_canvas.height-f4_Decke.hoehe-80);
	f4_Faden1.xe = f4_Kugel1.x;
	f4_Faden1.ye = f4_Kugel1.y;
	zeichneLinie(f4_context,f4_Faden1);
	zeichneKugel(f4_context,f4_Kugel1);
	f4_Faden2.xe = f4_Kugel2.x;
	f4_Faden2.ye = f4_Kugel2.y;
	zeichneLinie(f4_context,f4_Faden2);
	zeichneKugel(f4_context,f4_Kugel2);

	requestAnimFrame(function() {f4_animate();});
	}

function zeichneRechteck(context,R) {
	context.beginPath();
	context.rect(R.x, R.y, R.breite, R.hoehe);
	context.fillStyle = R.farbe;
	context.fill();
	if (R.randbreite > 0){
		context.lineWidth = R.randbreite;
		context.strokeStyle = R.randfarbe;
		context.lineCap = R.randenden;
		context.stroke();
		}
	}

function zeichneLinie(context,L) {
	context.beginPath();
	context.moveTo(L.xs, L.ys);
	context.lineTo(L.xe, L.ye);
	context.strokeStyle = L.farbe;
	context.lineWidth = L.breite;
	context.lineCap = L.enden;
	context.stroke();
	}

function zeichneKugel (context,K) {
	context.beginPath();
	context.arc(K.x, K.y, K.r, 0, 2.0*Math.PI);
	var grd = context.createRadialGradient(K.x-K.r/3, K.y-K.r/3, 0, K.x, K.y, K.r);
	grd.addColorStop(0, '#FFFFFF');
	grd.addColorStop(1, K.farbe);
	context.fillStyle = grd;
	context.fill();
	if (K.randbreite > 0){
		context.lineWidth = K.randbreite;
		context.strokeStyle = K.randfarbe;
		context.stroke();
		}
	}

function zeichneText(context,T,T_x,T_y,T_font,T_farbe) {
	context.font = T_font;
	context.fillStyle = T_farbe;
	context.fillText(T,T_x,T_y);
	}