﻿// Quiz_Fadenpendel_Frage_5_Animation 
// 06.10.2014

// ****************************************************************************
// * Autor: Thomas Unkelbach für LEIFIphysik.de                               *
// * Dieses Programm darf - auch in veränderter Form - für nicht-kommerzielle *
// * Zwecke verwendet und weitergegeben werden, solange dieser Hinweis nicht  *
// * entfernt wird.                                                           *
// ****************************************************************************

var f5_canvas = document.getElementById('f5_leinwand');
var f5_context = f5_canvas.getContext('2d');
var f5_t0 = (new Date()).getTime();

var f5_Decke = {
	x: 0,
	y: 0,
	breite: 350,
	hoehe: 25,
	farbe: '#5B135C',
	randbreite: 0,
	randfarbe: '#FFFFFF',
	randenden: 'round'
	};

var f5_Faden1 = {
	xs: 100,
	ys: 25,
	xe: 100,
	ye: 125,
	farbe: '#000000',
	breite: 1,
	enden: 'round'
	};

var f5_Kugel1 = {
	x: 100,
	y: 125,
	r: 20,
	farbe: '#C3C800',
	randbreite: 0,
	randfarbe: 'FFFFFF'
	};

var f5_l1 = 1;
var f5_g1 = 9.81;
var f5_T1 = 2 * Math.PI * Math.sqrt(f5_l1/f5_g1);

var f5_phi01 = Math.PI / 20;
var f5_x01 = 100;
var f5_y01 = 25;
var f5_r1 = 120 * f5_l1;

var f5_Faden2 = {
	xs: 250,
	ys: 25,
	xe: 250,
	ye: 125,
	farbe: '#000000',
	breite: 1,
	enden: 'round'
	};

var f5_Kugel2 = {
	x: 250,
	y: 125,
	r: 20,
	farbe: '#C3C800',
	randbreite: 0,
	randfarbe: 'FFFFFF'
	};

var f5_l2 = 1;
var f5_g2 = 9.81;
var f5_T2 = 2 * Math.PI * Math.sqrt(f5_l2/f5_g2);

var f5_phi02 = Math.PI / 10;
var f5_x02 = 250;
var f5_y02 = 25;
var f5_r2 = 120 * f5_l2;


document.addEventListener("DOMContentLoaded",f5_simulation(),false);

function f5_simulation (){
	window.requestAnimFrame = (function(callback) {return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || function(callback) {window.setTimeout(callback, 1000 / 60);};})();
	f5_init ();
	f5_animate ();
	}

function f5_init () {
	f5_Kugel1.x = f5_x01;
	f5_Kugel1.y = f5_y01 + f5_r1;
	f5_Kugel2.x = f5_x02;
	f5_Kugel2.y = f5_y02 + f5_r2;

	f5_context.clearRect(0, 0, f5_canvas.width, f5_canvas.height);
	zeichneRechteck(f5_context,f5_Decke);
	f5_Faden1.xe = f5_Kugel1.x;
	f5_Faden1.ye = f5_Kugel1.y;
	zeichneLinie(f5_context,f5_Faden1);
	zeichneKugel(f5_context,f5_Kugel1);
	f5_Faden2.xe = f5_Kugel2.x;
	f5_Faden2.ye = f5_Kugel2.y;
	zeichneLinie(f5_context,f5_Faden2);
	zeichneKugel(f5_context,f5_Kugel2);
	}

function f5_animate () {
	var t = ((new Date()).getTime() - f5_t0) / 1000;
	var phi1 = f5_phi01 * Math.sin(2 * Math.PI / f5_T1 * t);
	f5_Kugel1.x = f5_x01 - f5_r1 * Math.sin(phi1);
	f5_Kugel1.y = f5_y01 + f5_r1 * Math.cos(phi1);
	var phi2 = f5_phi02 * Math.sin(2 * Math.PI / f5_T2 * t);
	f5_Kugel2.x = f5_x02 - f5_r2 * Math.sin(phi2);
	f5_Kugel2.y = f5_y02 + f5_r2 * Math.cos(phi2);

	f5_context.clearRect(0, f5_Decke.hoehe, f5_canvas.width, f5_canvas.height-f5_Decke.hoehe);
	f5_Faden1.xe = f5_Kugel1.x;
	f5_Faden1.ye = f5_Kugel1.y;
	zeichneLinie(f5_context,f5_Faden1);
	zeichneKugel(f5_context,f5_Kugel1);
	f5_Faden2.xe = f5_Kugel2.x;
	f5_Faden2.ye = f5_Kugel2.y;
	zeichneLinie(f5_context,f5_Faden2);
	zeichneKugel(f5_context,f5_Kugel2);

	requestAnimFrame(function() {f5_animate();});
	}

function zeichneRechteck(context,R) {
	context.beginPath();
	context.rect(R.x, R.y, R.breite, R.hoehe);
	context.fillStyle = R.farbe;
	context.fill();
	if (R.randbreite > 0){
		context.lineWidth = R.randbreite;
		context.strokeStyle = R.randfarbe;
		context.lineCap = R.randenden;
		context.stroke();
		}
	}

function zeichneLinie(context,L) {
	context.beginPath();
	context.moveTo(L.xs, L.ys);
	context.lineTo(L.xe, L.ye);
	context.strokeStyle = L.farbe;
	context.lineWidth = L.breite;
	context.lineCap = L.enden;
	context.stroke();
	}

function zeichneKugel (context,K) {
	context.beginPath();
	context.arc(K.x, K.y, K.r, 0, 2.0*Math.PI);
	var grd = context.createRadialGradient(K.x-K.r/3, K.y-K.r/3, 0, K.x, K.y, K.r);
	grd.addColorStop(0, '#FFFFFF');
	grd.addColorStop(1, K.farbe);
	context.fillStyle = grd;
	context.fill();
	if (K.randbreite > 0){
		context.lineWidth = K.randbreite;
		context.strokeStyle = K.randfarbe;
		context.stroke();
		}
	}