﻿// Quiz_Fadenpendel_Frage_6_Animation 
// 06.10.2014

// ****************************************************************************
// * Autor: Thomas Unkelbach für LEIFIphysik.de                               *
// * Dieses Programm darf - auch in veränderter Form - für nicht-kommerzielle *
// * Zwecke verwendet und weitergegeben werden, solange dieser Hinweis nicht  *
// * entfernt wird.                                                           *
// ****************************************************************************

var f6_canvas = document.getElementById('f6_leinwand');
var f6_context = f6_canvas.getContext('2d');
var f6_t0 = (new Date()).getTime();

var f6_Decke = {
	x: 0,
	y: 0,
	breite: 350,
	hoehe: 25,
	farbe: '#5B135C',
	randbreite: 0,
	randfarbe: '#FFFFFF',
	randenden: 'round'
	};

var f6_Faden1 = {
	xs: 100,
	ys: 25,
	xe: 100,
	ye: 125,
	farbe: '#000000',
	breite: 1,
	enden: 'round'
	};

var f6_Kugel1 = {
	x: 100,
	y: 125,
	r: 20,
	farbe: '#C3C800',
	randbreite: 0,
	randfarbe: 'FFFFFF'
	};

var f6_l1 = 1;
var f6_g1 = 9.81;
var f6_T1 = 2 * Math.PI * Math.sqrt(f6_l1/f6_g1);

var f6_phi01 = Math.PI / 20;
var f6_x01 = 100;
var f6_y01 = 25;
var f6_r1 = 120 * f6_l1;

var f6_Faden2 = {
	xs: 250,
	ys: 25,
	xe: 250,
	ye: 125,
	farbe: '#000000',
	breite: 1,
	enden: 'round'
	};

var f6_Kugel2 = {
	x: 250,
	y: 125,
	r: 20,
	farbe: '#C3C800',
	randbreite: 0,
	randfarbe: 'FFFFFF'
	};

var f6_l2 = 0.5;
var f6_g2 = 9.81;
var f6_T2 = 2 * Math.PI * Math.sqrt(f6_l2/f6_g2);

var f6_phi02 = Math.PI / 20;
var f6_x02 = 250;
var f6_y02 = 25;
var f6_r2 = 120 * f6_l2;


document.addEventListener("DOMContentLoaded",f6_simulation(),false);

function f6_simulation (){
	window.requestAnimFrame = (function(callback) {return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || function(callback) {window.setTimeout(callback, 1000 / 60);};})();
	f6_init ();
	f6_animate ();
	}

function f6_init () {
	f6_Kugel1.x = f6_x01;
	f6_Kugel1.y = f6_y01 + f6_r1;
	f6_Kugel2.x = f6_x02;
	f6_Kugel2.y = f6_y02 + f6_r2;

	f6_context.clearRect(0, 0, f6_canvas.width, f6_canvas.height);
	zeichneRechteck(f6_context,f6_Decke);
	f6_Faden1.xe = f6_Kugel1.x;
	f6_Faden1.ye = f6_Kugel1.y;
	zeichneLinie(f6_context,f6_Faden1);
	zeichneKugel(f6_context,f6_Kugel1);
	f6_Faden2.xe = f6_Kugel2.x;
	f6_Faden2.ye = f6_Kugel2.y;
	zeichneLinie(f6_context,f6_Faden2);
	zeichneKugel(f6_context,f6_Kugel2);
	}

function f6_animate () {
	var t = ((new Date()).getTime() - f6_t0) / 1000;
	var phi1 = f6_phi01 * Math.sin(2 * Math.PI / f6_T1 * t);
	f6_Kugel1.x = f6_x01 - f6_r1 * Math.sin(phi1);
	f6_Kugel1.y = f6_y01 + f6_r1 * Math.cos(phi1);
	var phi2 = f6_phi02 * Math.sin(2 * Math.PI / f6_T2 * t);
	f6_Kugel2.x = f6_x02 - f6_r2 * Math.sin(phi2);
	f6_Kugel2.y = f6_y02 + f6_r2 * Math.cos(phi2);

	f6_context.clearRect(0, f6_Decke.hoehe, f6_canvas.width, f6_canvas.height-f6_Decke.hoehe);
	f6_Faden1.xe = f6_Kugel1.x;
	f6_Faden1.ye = f6_Kugel1.y;
	zeichneLinie(f6_context,f6_Faden1);
	zeichneKugel(f6_context,f6_Kugel1);
	f6_Faden2.xe = f6_Kugel2.x;
	f6_Faden2.ye = f6_Kugel2.y;
	zeichneLinie(f6_context,f6_Faden2);
	zeichneKugel(f6_context,f6_Kugel2);

	requestAnimFrame(function() {f6_animate();});
	}

function zeichneRechteck(context,R) {
	context.beginPath();
	context.rect(R.x, R.y, R.breite, R.hoehe);
	context.fillStyle = R.farbe;
	context.fill();
	if (R.randbreite > 0){
		context.lineWidth = R.randbreite;
		context.strokeStyle = R.randfarbe;
		context.lineCap = R.randenden;
		context.stroke();
		}
	}

function zeichneLinie(context,L) {
	context.beginPath();
	context.moveTo(L.xs, L.ys);
	context.lineTo(L.xe, L.ye);
	context.strokeStyle = L.farbe;
	context.lineWidth = L.breite;
	context.lineCap = L.enden;
	context.stroke();
	}

function zeichneKugel (context,K) {
	context.beginPath();
	context.arc(K.x, K.y, K.r, 0, 2.0*Math.PI);
	var grd = context.createRadialGradient(K.x-K.r/3, K.y-K.r/3, 0, K.x, K.y, K.r);
	grd.addColorStop(0, '#FFFFFF');
	grd.addColorStop(1, K.farbe);
	context.fillStyle = grd;
	context.fill();
	if (K.randbreite > 0){
		context.lineWidth = K.randbreite;
		context.strokeStyle = K.randfarbe;
		context.stroke();
		}
	}