﻿// Quiz_Fadenpendel_Frage_8_Animation 
// 06.10.2014

// ****************************************************************************
// * Autor: Thomas Unkelbach für LEIFIphysik.de                               *
// * Dieses Programm darf - auch in veränderter Form - für nicht-kommerzielle *
// * Zwecke verwendet und weitergegeben werden, solange dieser Hinweis nicht  *
// * entfernt wird.                                                           *
// ****************************************************************************

var f8_canvas = document.getElementById('f8_leinwand');
var f8_context = f8_canvas.getContext('2d');
var f8_t0 = (new Date()).getTime();

var f8_Decke = {
	x: 0,
	y: 0,
	breite: 350,
	hoehe: 25,
	farbe: '#5B135C',
	randbreite: 0,
	randfarbe: '#FFFFFF',
	randenden: 'round'
	};

var f8_Faden1 = {
	xs: 100,
	ys: 25,
	xe: 100,
	ye: 125,
	farbe: '#000000',
	breite: 1,
	enden: 'round'
	};

var f8_Kugel1 = {
	x: 100,
	y: 125,
	r: 20,
	farbe: '#C3C800',
	randbreite: 0,
	randfarbe: 'FFFFFF'
	};

var f8_l1 = 1;
var f8_g1 = 9.81;
var f8_T1 = 2 * Math.PI * Math.sqrt(f8_l1/f8_g1);

var f8_phi01 = Math.PI / 20;
var f8_x01 = 100;
var f8_y01 = 25;
var f8_r1 = 120 * f8_l1;

var f8_Faden2 = {
	xs: 250,
	ys: 25,
	xe: 250,
	ye: 125,
	farbe: '#000000',
	breite: 1,
	enden: 'round'
	};

var f8_Kugel2 = {
	x: 250,
	y: 125,
	r: 20,
	farbe: '#C3C800',
	randbreite: 0,
	randfarbe: 'FFFFFF'
	};

var f8_l2 = 1;
var f8_g2 = 5;
var f8_T2 = 2 * Math.PI * Math.sqrt(f8_l2/f8_g2);

var f8_phi02 = Math.PI / 20;
var f8_x02 = 250;
var f8_y02 = 25;
var f8_r2 = 120 * f8_l2;


document.addEventListener("DOMContentLoaded",f8_simulation(),false);

function f8_simulation (){
	window.requestAnimFrame = (function(callback) {return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || function(callback) {window.setTimeout(callback, 1000 / 60);};})();
	f8_init ();
	f8_animate ();
	}

function f8_init () {
	f8_Kugel1.x = f8_x01;
	f8_Kugel1.y = f8_y01 + f8_r1;
	f8_Kugel2.x = f8_x02;
	f8_Kugel2.y = f8_y02 + f8_r2;

	f8_context.clearRect(0, 0, f8_canvas.width, f8_canvas.height);
	zeichneRechteck(f8_context,f8_Decke);
	f8_Faden1.xe = f8_Kugel1.x;
	f8_Faden1.ye = f8_Kugel1.y;
	zeichneLinie(f8_context,f8_Faden1);
	zeichneKugel(f8_context,f8_Kugel1);
	zeichneText(f8_context,'g',94,200,'16pt Arial','#000000');
	zeichneText(f8_context,'1',106,205,'10pt Arial','#000000');
	f8_Faden2.xe = f8_Kugel2.x;
	f8_Faden2.ye = f8_Kugel2.y;
	zeichneLinie(f8_context,f8_Faden2);
	zeichneKugel(f8_context,f8_Kugel2);
	zeichneText(f8_context,'g  < g',225,200,'16pt Arial','#000000');
	zeichneText(f8_context,'2',237,205,'10pt Arial','#000000');
	zeichneText(f8_context,'1',278,205,'10pt Arial','#000000');
	}

function f8_animate () {
	var t = ((new Date()).getTime() - f8_t0) / 1000;
	var phi1 = f8_phi01 * Math.sin(2 * Math.PI / f8_T1 * t);
	f8_Kugel1.x = f8_x01 - f8_r1 * Math.sin(phi1);
	f8_Kugel1.y = f8_y01 + f8_r1 * Math.cos(phi1);
	var phi2 = f8_phi02 * Math.sin(2 * Math.PI / f8_T2 * t);
	f8_Kugel2.x = f8_x02 - f8_r2 * Math.sin(phi2);
	f8_Kugel2.y = f8_y02 + f8_r2 * Math.cos(phi2);

	f8_context.clearRect(0, f8_Decke.hoehe, f8_canvas.width, f8_canvas.height-f8_Decke.hoehe-80);
	f8_Faden1.xe = f8_Kugel1.x;
	f8_Faden1.ye = f8_Kugel1.y;
	zeichneLinie(f8_context,f8_Faden1);
	zeichneKugel(f8_context,f8_Kugel1);
	f8_Faden2.xe = f8_Kugel2.x;
	f8_Faden2.ye = f8_Kugel2.y;
	zeichneLinie(f8_context,f8_Faden2);
	zeichneKugel(f8_context,f8_Kugel2);

	requestAnimFrame(function() {f8_animate();});
	}

function zeichneRechteck(context,R) {
	context.beginPath();
	context.rect(R.x, R.y, R.breite, R.hoehe);
	context.fillStyle = R.farbe;
	context.fill();
	if (R.randbreite > 0){
		context.lineWidth = R.randbreite;
		context.strokeStyle = R.randfarbe;
		context.lineCap = R.randenden;
		context.stroke();
		}
	}

function zeichneLinie(context,L) {
	context.beginPath();
	context.moveTo(L.xs, L.ys);
	context.lineTo(L.xe, L.ye);
	context.strokeStyle = L.farbe;
	context.lineWidth = L.breite;
	context.lineCap = L.enden;
	context.stroke();
	}

function zeichneKugel (context,K) {
	context.beginPath();
	context.arc(K.x, K.y, K.r, 0, 2.0*Math.PI);
	var grd = context.createRadialGradient(K.x-K.r/3, K.y-K.r/3, 0, K.x, K.y, K.r);
	grd.addColorStop(0, '#FFFFFF');
	grd.addColorStop(1, K.farbe);
	context.fillStyle = grd;
	context.fill();
	if (K.randbreite > 0){
		context.lineWidth = K.randbreite;
		context.strokeStyle = K.randfarbe;
		context.stroke();
		}
	}

function zeichneText(context,T,T_x,T_y,T_font,T_farbe) {
	context.font = T_font;
	context.fillStyle = T_farbe;
	context.fillText(T,T_x,T_y);
	}