﻿// Quiz_Fadenpendel_Frage_9_Animation 
// 06.10.2014

// ****************************************************************************
// * Autor: Thomas Unkelbach für LEIFIphysik.de                               *
// * Dieses Programm darf - auch in veränderter Form - für nicht-kommerzielle *
// * Zwecke verwendet und weitergegeben werden, solange dieser Hinweis nicht  *
// * entfernt wird.                                                           *
// ****************************************************************************

var f9_canvas = document.getElementById('f9_leinwand');
var f9_context = f9_canvas.getContext('2d');
var f9_t0 = (new Date()).getTime();

var f9_Decke = {
	x: 0,
	y: 0,
	breite: 350,
	hoehe: 25,
	farbe: '#5B135C',
	randbreite: 0,
	randfarbe: '#FFFFFF',
	randenden: 'round'
	};

var f9_Faden1 = {
	xs: 100,
	ys: 25,
	xe: 100,
	ye: 125,
	farbe: '#000000',
	breite: 1,
	enden: 'round'
	};

var f9_Kugel1 = {
	x: 100,
	y: 125,
	r: 20,
	farbe: '#C3C800',
	randbreite: 0,
	randfarbe: 'FFFFFF'
	};

var f9_l1 = 1;
var f9_g1 = 9.81;
var f9_T1 = 2 * Math.PI * Math.sqrt(f9_l1/f9_g1);

var f9_phi01 = Math.PI / 20;
var f9_x01 = 100;
var f9_y01 = 25;
var f9_r1 = 120 * f9_l1;

var f9_Faden2 = {
	xs: 250,
	ys: 25,
	xe: 250,
	ye: 125,
	farbe: '#000000',
	breite: 1,
	enden: 'round'
	};

var f9_Kugel2 = {
	x: 250,
	y: 125,
	r: 20,
	farbe: '#C3C800',
	randbreite: 0,
	randfarbe: 'FFFFFF'
	};

var f9_l2 = 1;
var f9_g2 = 9.81;
var f9_T2 = 2 * Math.PI * Math.sqrt(f9_l2/f9_g2);

var f9_phi02 = Math.PI / 40;
var f9_x02 = 250;
var f9_y02 = 25;
var f9_r2 = 120 * f9_l2;


document.addEventListener("DOMContentLoaded",f9_simulation(),false);

function f9_simulation (){
	window.requestAnimFrame = (function(callback) {return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || function(callback) {window.setTimeout(callback, 1000 / 60);};})();
	f9_init ();
	f9_animate ();
	}

function f9_init () {
	f9_Kugel1.x = f9_x01;
	f9_Kugel1.y = f9_y01 + f9_r1;
	f9_Kugel2.x = f9_x02;
	f9_Kugel2.y = f9_y02 + f9_r2;

	f9_context.clearRect(0, 0, f9_canvas.width, f9_canvas.height);
	zeichneRechteck(f9_context,f9_Decke);
	f9_Faden1.xe = f9_Kugel1.x;
	f9_Faden1.ye = f9_Kugel1.y;
	zeichneLinie(f9_context,f9_Faden1);
	zeichneKugel(f9_context,f9_Kugel1);
	f9_Faden2.xe = f9_Kugel2.x;
	f9_Faden2.ye = f9_Kugel2.y;
	zeichneLinie(f9_context,f9_Faden2);
	zeichneKugel(f9_context,f9_Kugel2);
	}

function f9_animate () {
	var t = ((new Date()).getTime() - f9_t0) / 1000;
	var phi1 = f9_phi01 * Math.sin(2 * Math.PI / f9_T1 * t);
	f9_Kugel1.x = f9_x01 - f9_r1 * Math.sin(phi1);
	f9_Kugel1.y = f9_y01 + f9_r1 * Math.cos(phi1);
	var phi2 = f9_phi02 * Math.sin(2 * Math.PI / f9_T2 * t);
	f9_Kugel2.x = f9_x02 - f9_r2 * Math.sin(phi2);
	f9_Kugel2.y = f9_y02 + f9_r2 * Math.cos(phi2);

	f9_context.clearRect(0, f9_Decke.hoehe, f9_canvas.width, f9_canvas.height-f9_Decke.hoehe);
	f9_Faden1.xe = f9_Kugel1.x;
	f9_Faden1.ye = f9_Kugel1.y;
	zeichneLinie(f9_context,f9_Faden1);
	zeichneKugel(f9_context,f9_Kugel1);
	f9_Faden2.xe = f9_Kugel2.x;
	f9_Faden2.ye = f9_Kugel2.y;
	zeichneLinie(f9_context,f9_Faden2);
	zeichneKugel(f9_context,f9_Kugel2);

	requestAnimFrame(function() {f9_animate();});
	}

function zeichneRechteck(context,R) {
	context.beginPath();
	context.rect(R.x, R.y, R.breite, R.hoehe);
	context.fillStyle = R.farbe;
	context.fill();
	if (R.randbreite > 0){
		context.lineWidth = R.randbreite;
		context.strokeStyle = R.randfarbe;
		context.lineCap = R.randenden;
		context.stroke();
		}
	}

function zeichneLinie(context,L) {
	context.beginPath();
	context.moveTo(L.xs, L.ys);
	context.lineTo(L.xe, L.ye);
	context.strokeStyle = L.farbe;
	context.lineWidth = L.breite;
	context.lineCap = L.enden;
	context.stroke();
	}

function zeichneKugel (context,K) {
	context.beginPath();
	context.arc(K.x, K.y, K.r, 0, 2.0*Math.PI);
	var grd = context.createRadialGradient(K.x-K.r/3, K.y-K.r/3, 0, K.x, K.y, K.r);
	grd.addColorStop(0, '#FFFFFF');
	grd.addColorStop(1, K.farbe);
	context.fillStyle = grd;
	context.fill();
	if (K.randbreite > 0){
		context.lineWidth = K.randbreite;
		context.strokeStyle = K.randfarbe;
		context.stroke();
		}
	}